"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function getCurrentBrowserWindowState(page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (page) {
            const windowStateSerialized = yield page.evaluate(() => {
                const result = {
                    innerHeight: window.innerHeight,
                    innerWidth: window.innerWidth,
                    outerWidth: window.outerWidth,
                    outerHeight: window.outerHeight,
                    screen: {
                        availWidth: window.screen.availWidth,
                        availHeight: window.screen.availHeight,
                    },
                    isMaximized: Math.abs(window.outerWidth - window.screen.availWidth) <
                        window.screen.availWidth * 0.03 &&
                        Math.abs(window.outerHeight - window.screen.availHeight) < 100,
                };
                return JSON.stringify(result);
            });
            const windowState = JSON.parse(windowStateSerialized);
            return windowState;
        }
        throw new Error('Error: cannot get current window because a new page has not been created');
    });
}
exports.getCurrentBrowserWindowState = getCurrentBrowserWindowState;
