"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const get_current_url_1 = require("../get-current-url");
function getTabByUrl(browser, url) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!browser) {
            throw new Error('Error: cannot get an existing page because the browser has not been launched');
        }
        const pages = yield browser.pages();
        const foundPages = [];
        for (let index = 0; index < pages.length; index++) {
            const page = pages[index];
            const currentUrl = yield get_current_url_1.getCurrentUrl(page);
            if (currentUrl && currentUrl.includes(url)) {
                foundPages.push(page);
            }
        }
        if (foundPages.length > 0) {
            return foundPages[0];
        }
        throw new Error(`Error: cannot find page with url '${url}' on current browser instance`);
    });
}
exports.getTabByUrl = getTabByUrl;
