import * as puppeteer from 'puppeteer-core';
import { Device } from '../page-actions/emulate-device';
export interface MinViewPort {
    /**
     * min page width in pixels.
     */
    minWidth: number;
    /**
     * min page height in pixels.
     */
    minHeight: number;
}
export interface LaunchOptions extends puppeteer.LaunchOptions {
    browserWindowShouldBeMaximized?: boolean;
    emulateDevice?: Device;
    minViewPort?: MinViewPort;
    recordFailedRequests?: boolean;
    additionalFailedStatus?: number[];
    recordPageErrors?: boolean;
    showCursor?: boolean;
}
export declare function launchBrowserWithMaxSizeWindow(options: Partial<LaunchOptions>): Promise<puppeteer.Browser>;
export declare function launchBrowserWithEmulatedDevice(options: Partial<LaunchOptions>): Promise<puppeteer.Browser>;
export declare function launchBrowser(options: Partial<LaunchOptions>): Promise<puppeteer.Browser>;
