"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const dom_actions_1 = require("../../dom-actions");
function startNewPageInBrowser(browser, showCursor = false) {
    return __awaiter(this, void 0, void 0, function* () {
        if (browser && showCursor) {
            const page = yield browser.newPage();
            yield dom_actions_1.showMousePosition(page);
            return page;
        }
        if (browser) {
            return yield browser.newPage();
        }
        throw new Error('Error: cannot create a new page because the browser has not been launched');
    });
}
exports.startNewPageInBrowser = startNewPageInBrowser;
