"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const is_option_available_in_1 = require("../is-option-available-in");
function areOptionsAvailableIn(selector, expectedOptionLabels, page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot check if options [${expectedOptionLabels.join(',')}] are available in '${selector}' because a new page has not been created`);
        }
        if (expectedOptionLabels.length === 0) {
            throw new Error('No option to check: you must specify at least one option');
        }
        for (let index = 0; index < expectedOptionLabels.length; index++) {
            const expectedOptionLabel = expectedOptionLabels[index];
            const isAvailable = yield is_option_available_in_1.isOptionAvailableIn(selector, expectedOptionLabel, page);
            if (!isAvailable) {
                return false;
            }
        }
        return true;
    });
}
exports.areOptionsAvailableIn = areOptionsAvailableIn;
