"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function exists(selector, page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot check that '${selector}' exists because a new page has not been created`);
        }
        try {
            const result = yield page.$(selector);
            if (result === null) {
                return false;
            }
            return true;
        }
        catch (error) {
            // eslint-disable-next-line no-console
            console.warn(`An internal error has occured in Puppeteer API while checking if selector '${selector}'  exists`, error);
            return false;
        }
    });
}
exports.exists = exists;
