"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function getAllOptionsOf(selector, page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot get the options of '${selector}' because a new page has not been created`);
        }
        const result = yield page.$eval(selector, (el) => {
            const selectElement = el;
            if (!selectElement) {
                return null;
            }
            if (!selectElement.options) {
                return null;
            }
            const options = Array.from(selectElement.options);
            const infos = options.map((option) => {
                return {
                    value: option.value,
                    label: option.label,
                    selected: option.selected,
                };
            });
            return JSON.stringify(infos);
        });
        if (result === null) {
            throw new Error(`Cannot find any options in selector '${selector}'`);
        }
        const optionsInfos = JSON.parse(result);
        return optionsInfos;
    });
}
exports.getAllOptionsOf = getAllOptionsOf;
