"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function getClientRectangleOf(selector, page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot get the client rectangle of '${selector}' because a new page has not been created`);
        }
        const stringifiedResult = yield page.$eval(selector, (el) => {
            const clientRectangle = el && el.getBoundingClientRect();
            const result = {
                bottom: clientRectangle ? clientRectangle.bottom : 0,
                height: clientRectangle ? clientRectangle.height : 0,
                top: clientRectangle ? clientRectangle.top : 0,
                width: clientRectangle ? clientRectangle.width : 0,
                left: clientRectangle ? clientRectangle.left : 0,
                right: clientRectangle ? clientRectangle.right : 0,
            };
            return JSON.stringify(result);
        });
        const clientRectangle = JSON.parse(stringifiedResult);
        return Promise.resolve(clientRectangle);
    });
}
exports.getClientRectangleOf = getClientRectangleOf;
