"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function getSelectedOptionOf(selector, page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot get the selected option of '${selector}' because a new page has not been created`);
        }
        const stringifiedResult = yield page.$eval(selector, (el) => {
            const selectElement = el;
            if (!selectElement) {
                return null;
            }
            if (!selectElement.selectedOptions) {
                return null;
            }
            const selectedOptions = Array.from(selectElement.selectedOptions);
            if (selectedOptions.length === 0) {
                return null;
            }
            const optionInfo = {
                label: selectedOptions[0].label,
                selected: true,
                value: selectedOptions[0].value,
            };
            return JSON.stringify(optionInfo);
        });
        const result = stringifiedResult === null ? null : JSON.parse(stringifiedResult);
        return result;
    });
}
exports.getSelectedOptionOf = getSelectedOptionOf;
