"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function hasActiveElement(page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot check that page has an active element because a new page has not been created`);
        }
        const result = yield page.$eval('html > body', (el) => {
            const focusedElement = window.document.activeElement;
            if (!focusedElement) {
                return false;
            }
            if (focusedElement.tagName === el.tagName) {
                return false;
            }
            return true;
        });
        return result;
    });
}
exports.hasActiveElement = hasActiveElement;
