"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const has_attribute_1 = require("../has-attribute");
function hasAttributeWithValue(selector, attributeName, expectedValue, page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot get attribute '${attributeName}' of '${selector}' because a new page has not been created`);
        }
        const atrributeExists = yield has_attribute_1.hasAttribute(selector, attributeName, page);
        if (!atrributeExists) {
            return false;
        }
        const attributeValue = yield page.$eval(selector, (el, attr) => {
            const value = el.getAttribute(attr);
            if (value === null) {
                return 'null';
            }
            return value;
        }, attributeName);
        return attributeValue === expectedValue;
    });
}
exports.hasAttributeWithValue = hasAttributeWithValue;
