"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function hasAttribute(selector, attributeName, page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot get attribute '${attributeName}' of '${selector}' because a new page has not been created`);
        }
        const hasAttribute = yield page.$eval(selector, (el, attr) => {
            const value = el.getAttribute(attr);
            if (value === null) {
                return 'false';
            }
            return 'true';
        }, attributeName);
        const result = hasAttribute === 'true' ? true : false;
        return result;
    });
}
exports.hasAttribute = hasAttribute;
