"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const get_client_rectangle_of_1 = require("../get-client-rectangle-of");
const utils_1 = require("../../../utils");
exports.zeroClientRectangle = {
    top: 0,
    left: 0,
    width: 1,
    height: 1,
    bottom: 0,
    right: 0,
};
function hasMoved(selector, previousClientRectangle, page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot check that '${selector}' has moved because a new page has not been created`);
        }
        const currentClientRectangle = yield get_client_rectangle_of_1.getClientRectangleOf(selector, page);
        const threshold = 5;
        const distance = utils_1.getDistanceBetweenClientRectangles(currentClientRectangle, previousClientRectangle);
        return distance >= threshold;
    });
}
exports.hasMoved = hasMoved;
