"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const get_client_rectangle_of_1 = require("../get-client-rectangle-of");
const has_moved_1 = require("../has-moved");
function isMoving(selector, page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot check that '${selector}' is moving because a new page has not been created`);
        }
        const previousClientRectangle = yield get_client_rectangle_of_1.getClientRectangleOf(selector, page);
        yield page.waitFor(50);
        const result = yield has_moved_1.hasMoved(selector, previousClientRectangle, page);
        return result;
    });
}
exports.isMoving = isMoving;
