"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const get_all_options_of_1 = require("../get-all-options-of");
function isOptionAvailableIn(selector, expectedOptionLabel, page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot check if option '${expectedOptionLabel}' is available in '${selector}' because a new page has not been created`);
        }
        const availableOptions = yield get_all_options_of_1.getAllOptionsOf(selector, page);
        const foundOption = availableOptions
            .filter((option) => option.label === expectedOptionLabel)
            .shift();
        if (foundOption) {
            return true;
        }
        return false;
    });
}
exports.isOptionAvailableIn = isOptionAvailableIn;
