"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultPasteOptions = {
    handlePasteEvent: false,
};
function pasteText(selector, text, options, page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot paste text '${text}' in '${selector}' because a new page has not been created`);
        }
        yield page.$eval(selector, (el, content, handlePasteEvent) => {
            function attachPasteEvent(el) {
                el.addEventListener('paste', (event) => {
                    // eslint-disable-next-line @typescript-eslint/no-explicit-any
                    const content = (event.clipboardData || window.clipboardData).getData('text');
                    const input = event.target;
                    if (event.target && input && input.tagName === 'INPUT') {
                        input.value = content;
                        event.preventDefault();
                        return;
                    }
                    event.target.innerText = content;
                    event.preventDefault();
                });
            }
            if (handlePasteEvent) {
                attachPasteEvent(el);
            }
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            window.clipboardData = { getData: () => content };
            // eslint-disable-next-line no-undef
            const event = new CustomEvent('paste', {
                bubbles: true,
            });
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            event.clipboardData = { getData: () => content };
            el.dispatchEvent(event);
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            window.clipboardData = undefined;
        }, text, options.handlePasteEvent);
    });
}
exports.pasteText = pasteText;
