"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function querySelectorWithExactText(selector, text, page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot query selector '${selector}' with text '${text}' because a new page has not been created`);
        }
        const elements = yield page.$$(selector);
        if (elements.length === 0) {
            throw new Error(`Error: Cannot find selector '${selector}'`);
        }
        for (let index = 0; index < elements.length; index++) {
            const element = elements[index];
            const innerText = yield element.evaluate((node) => {
                const nodeWithText = node;
                if (nodeWithText && nodeWithText.innerText) {
                    return nodeWithText.innerText.trim();
                }
                return undefined;
            });
            if (innerText === text) {
                return element;
            }
        }
        throw new Error(`Error: Cannot find a selector '${selector}' with exact text '${text}'`);
    });
}
exports.querySelectorWithExactText = querySelectorWithExactText;
