"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function getNthElement(index, elements) {
    return __awaiter(this, void 0, void 0, function* () {
        if (index === 0) {
            throw new Error('Index is one-based');
        }
        if (Math.abs(index) > elements.length) {
            return [];
        }
        const currentHandles = [...elements];
        if (index > 0) {
            let nthHandle;
            for (let i = 1; i <= index; i++) {
                nthHandle = currentHandles.shift();
            }
            return nthHandle ? [nthHandle] : [];
        }
        if (index < 0) {
            let nthHandle;
            for (let i = 1; i <= -index; i++) {
                nthHandle = currentHandles.pop();
            }
            return nthHandle ? [nthHandle] : [];
        }
        return [];
    });
}
exports.getNthElement = getNthElement;
