"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("..");
function isOptionAvailableInHandle(selector, expectedOptionLabel) {
    return __awaiter(this, void 0, void 0, function* () {
        if (selector === undefined || selector === null) {
            return false;
        }
        const availableOptions = yield __1.getAllOptionsOfHandle(selector);
        const foundOption = availableOptions
            .filter((option) => option.label === expectedOptionLabel)
            .shift();
        if (foundOption) {
            return true;
        }
        return false;
    });
}
exports.isOptionAvailableInHandle = isOptionAvailableInHandle;
