"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("..");
const utils_1 = require("../../../utils");
function waitUntilHandleDoesNotMove(selector, selectorName, options) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!selector) {
            return;
        }
        const waitIntervalForIsMovingFunc = 50;
        const waitInterval = 10;
        let elapsedTime = 0;
        let stabilityCounter = 0;
        const maxStabilityCounter = 7;
        // eslint-disable-next-line no-constant-condition
        while (true) {
            if (elapsedTime > options.timeoutInMilliseconds) {
                throw new Error(`Error: Selector '${selectorName}' is still moving after ${options.timeoutInMilliseconds} ms`);
            }
            if (stabilityCounter >= maxStabilityCounter) {
                return;
            }
            const isCurrentlyMoving = yield __1.isHandleMoving(selector);
            if (isCurrentlyMoving) {
                yield utils_1.sleep(waitInterval);
                stabilityCounter = 0;
                elapsedTime += waitIntervalForIsMovingFunc + waitInterval;
                continue;
            }
            stabilityCounter += 1;
            elapsedTime += waitIntervalForIsMovingFunc;
        }
    });
}
exports.waitUntilHandleDoesNotMove = waitUntilHandleDoesNotMove;
