"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const dom_actions_1 = require("../../dom-actions");
const __1 = require("..");
function clickOnSelectorWithExactText(selector, text, options, page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot click on '${selector}' because a new page has not been created`);
        }
        const puppeteerClickOptions = {
            button: options.button,
            delay: options.delay,
            clickCount: options.clickCount,
        };
        yield __1.waitUntilSelectorWithExactTextIsVisible(selector, text, { timeoutInMilliseconds: options.timeoutInMilliseconds }, page);
        const element = yield dom_actions_1.querySelectorWithExactText(selector, text, page);
        yield element.hover();
        yield element.click(puppeteerClickOptions);
    });
}
exports.clickOnSelectorWithExactText = clickOnSelectorWithExactText;
