"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../index");
function click(selector, options, page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot click on '${selector}' because a new page has not been created`);
        }
        const puppeteerClickOptions = {
            button: options.button,
            delay: options.delay,
            clickCount: options.clickCount,
        };
        yield index_1.waitUntilSelectorIsVisible(selector, { timeoutInMilliseconds: options.timeoutInMilliseconds }, page);
        yield index_1.waitUntilSelectorDoesNotMove(selector, {
            timeoutInMilliseconds: options.timeoutInMilliseconds,
        }, page);
        yield page.click(selector, puppeteerClickOptions);
    });
}
exports.click = click;
