"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function getViewportRectangleOf(page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot get the viewport because a new page has not been created`);
        }
        const stringifiedResult = yield page.evaluate(() => {
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            const viewportRectangle = window.visualViewport;
            if (!viewportRectangle) {
                return null;
            }
            const result = {
                height: viewportRectangle.height,
                offsetLeft: viewportRectangle.offsetLeft,
                offsetTop: viewportRectangle.offsetTop,
                pageLeft: viewportRectangle.pageLeft,
                pageTop: viewportRectangle.pageTop,
                scale: viewportRectangle.scale,
                width: viewportRectangle.width,
            };
            return JSON.stringify(result);
        });
        if (stringifiedResult === null) {
            return null;
        }
        const rectangle = JSON.parse(stringifiedResult);
        return rectangle;
    });
}
exports.getViewportRectangleOf = getViewportRectangleOf;
