"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const dom_actions_1 = require("../../dom-actions");
const __1 = require("..");
exports.defaultHoverOptions = {
    timeoutInMilliseconds: 30000,
    steps: 10,
};
function hover(selector, options, page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot hover to '${selector}' because a new page has not been created`);
        }
        yield __1.waitUntilSelectorIsVisible(selector, { timeoutInMilliseconds: options.timeoutInMilliseconds }, page);
        yield __1.waitUntilSelectorDoesNotMove(selector, {
            timeoutInMilliseconds: options.timeoutInMilliseconds,
        }, page);
        yield dom_actions_1.scrollTo(selector, page);
        yield __1.waitUntilSelectorDoesNotMove(selector, {
            timeoutInMilliseconds: options.timeoutInMilliseconds,
        }, page);
        for (let index = 0; index < 3; index++) {
            yield page.waitFor(50);
            const clientRectangle = yield dom_actions_1.getClientRectangleOf(selector, page);
            const x = clientRectangle.left + clientRectangle.width / 2;
            const y = clientRectangle.top + clientRectangle.height / 2;
            yield page.mouse.move(x, y, { steps: options.steps });
        }
    });
}
exports.hover = hover;
