"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const dom_actions_1 = require("../../dom-actions");
function queryActiveElement(page) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot query active element because a new page has not been created`);
        }
        const hasActiveElementInPage = yield dom_actions_1.hasActiveElement(page);
        if (!hasActiveElementInPage) {
            return null;
        }
        const activeElement = yield page.evaluateHandle(() => window.document.activeElement);
        return activeElement.asElement();
    });
}
exports.queryActiveElement = queryActiveElement;
