"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const failedStatus = [500, 503, 400, 401, 403, 404, 307];
function recordFailedRequests(page, additionalFailedStatus, callback) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!page) {
            throw new Error(`Error: cannot record failed requests because a new page has not been created`);
        }
        page.on('requestfinished', (request) => {
            const response = request.response();
            if (response === null) {
                callback(request);
                return;
            }
            const status = response.status();
            if (failedStatus.includes(status)) {
                callback(request);
                return;
            }
            if (additionalFailedStatus.includes(status)) {
                callback(request);
                return;
            }
        });
        page.on('requestfailed', (request) => {
            callback(request);
        });
    });
}
exports.recordFailedRequests = recordFailedRequests;
