"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const os = __importStar(require("os"));
const which = __importStar(require("which"));
const currentPlatformType = os.type();
function getChromePath() {
    switch (currentPlatformType) {
        case 'Darwin':
            return '/Applications/Google Chrome.app/Contents/MacOS/Google Chrome';
        case 'Windows_NT':
            return 'C:/Program Files (x86)/Google/Chrome/Application/chrome.exe';
        case 'Linux':
            if (which.sync('google-chrome-stable')) {
                return 'google-chrome-stable';
            }
            return 'google-chrome';
        default:
            throw new Error('Error: you should supply the path to the Chrome App in the launch options');
    }
}
exports.getChromePath = getChromePath;
