"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const os = __importStar(require("os"));
const which = __importStar(require("which"));
const currentPlatformType = os.type();
function getFirefoxPath() {
    switch (currentPlatformType) {
        case 'Darwin':
            return '/Applications/Firefox.app/Contents/MacOS/firefox';
        case 'Windows_NT':
            return 'C:/Program Files (x86)/Mozilla Firefox/firefox.exe';
        case 'Linux':
            if (which.sync('firefox')) {
                return which.sync('firefox');
            }
            return 'firefox';
        default:
            throw new Error('Error: you should supply the path to the Firefox App in the launch options');
    }
}
exports.getFirefoxPath = getFirefoxPath;
