import * as puppeteer from 'puppeteer-core';
export interface RequestInfo {
    url: string;
    method: string;
    error: {
        errorText: string;
    } | null;
    headers: {
        [key: string]: string;
    };
    postData: string | unknown | undefined;
    response: ResponseInfo | null;
}
export interface ResponseInfo {
    headers: {
        [key: string]: string;
    };
    status: number;
    payload: string | unknown | undefined;
}
export declare function stringifyRequest(request: puppeteer.Request): Promise<string>;
