"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function toJsonOrDefault(data) {
    try {
        if (!data) {
            return data;
        }
        return JSON.parse(data);
    }
    catch (error) {
        return data;
    }
}
function toJsonOrText(response) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const payload = yield response.json();
            return payload;
        }
        catch (error) {
            return yield response.text();
        }
    });
}
function stringifyRequest(request) {
    return __awaiter(this, void 0, void 0, function* () {
        const requestInfo = {
            url: request.url(),
            method: request.method(),
            error: request.failure(),
            headers: request.headers(),
            postData: toJsonOrDefault(request.postData()),
            response: null,
        };
        const response = request.response();
        if (response === null) {
            const result = JSON.stringify(requestInfo, null, 2);
            return result;
        }
        let responseBody = undefined;
        try {
            responseBody = yield toJsonOrText(response);
        }
        catch (error) {
            // ignore error
        }
        const responseInfo = {
            status: response.status(),
            headers: response.headers(),
            payload: responseBody,
        };
        requestInfo.response = responseInfo;
        const result = JSON.stringify(requestInfo, null, 2);
        return result;
    });
}
exports.stringifyRequest = stringifyRequest;
